<?php

$install_path = $_SERVER["DOCUMENT_ROOT"];
$config = $install_path . "/common/common.inc.php";

if(isset($_POST['install_path'])){
	$install_path = $_POST['install_path'];
	$config = $install_path . "/common/common.inc.php";
	
	if(file_exists($config)){
		
		include_once($config);
		
		outputHeader();
		execute();
		outputFooter();
		
		exit;
		
	}else{
		$error = true;
	}
}

outputHeader();
if(@$error)outputError();
outputBody();
outputFooter();

/* --------------------------------------------------------------------------------------- */

function outputBody(){
	global $install_path;
	
	$path = htmlspecialchars($install_path,ENT_QUOTES);

echo <<<HTML
<form method="post">
	<p>SOYCMSのインストール先を選択してください。</p>
	<input type="text" name="install_path" value="$path" size="120" />
	<p>
		<input type="submit" value="実行" />
	</p>
</form>
HTML;
}

function outputError(){
	echo "<p style='color:red'>指定された場所にはSOYCMSがインストールされていません。</p>";	
}


function outputHeader(){
	echo <<<HEADER_HTML
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>SOYCMS Version Up Program</title>
</head>
<body>
<h1>SOYCMS 高速化パッチ</h1>
HEADER_HTML;
}

function outputFooter(){
	echo <<<FOOTER_HTML
</body>
</html>
FOOTER_HTML;
}


/**
 * バージョンアップ実行
 */
function execute(){
	
	//$checkSQL = "select display_order,color,background_color from Label";
		
	$sql = array(
		"create index entry_udate on Entry(udate desc)",	
	);
	
	SOY2DAOConfig::Dsn(ADMIN_DB_DSN);
	SOY2DAOConfig::user(ADMIN_DB_USER);
	SOY2DAOConfig::pass(ADMIN_DB_PASS);
	
	//サイトを取得
	$siteDAO = SOY2DAOFactory::create("admin.SiteDAO");
	$sites = $siteDAO->get();
	
	$failed = array();
	
	foreach($sites as $key => $site){
		
		try{
			switch(SOYCMS_DB_TYPE){
				case "mysql":
					$pdo = new PDO($site->getDataSourceName(),ADMIN_DB_USER,ADMIN_DB_PASS,array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
					break;
				case "sqlite":
				default:
					if(!is_writable($site->getPath().".db/sqlite.db")){
						$failed[$key] .= "このファイルへの書き込み権限はありません。<br/>";
					}
					$pdo = new PDO("sqlite:".$site->getPath().".db/sqlite.db","","",array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
					break;
			}
		}catch(Exception $e){
			if(!is_writable($site->getPath().".db/sqlite.db")){
				$failed[$key] .= "データーベースをオープン出来ませんでした。<br/>";
			}
			continue;
		}
		
//		try{
//			$pdo->exec($checkSQL);
//			
//			//既にカラムは追加済み
//			echo "<p>";
//			echo $site->getSiteName() . "のバージョンは既に変更しているため、スキップしました。";
//			echo "</p>";
//			continue;
//		}catch(Exception $e){
//			
//		}
		
		$tmpFailed = false;
		
		foreach($sql as $query){
			try{
				$pdo->exec($query);
			}catch(Exception $e){
				$tmpFailed = true;
				$failed[$key] .= $e->getMessage()."<br/>";
			}
		}
		
		if(!$tmpFailed){
			echo "<p>";
			echo $site->getSiteName() . "のデータベースを変更しました。";
			echo "</p>";
		}
	}
	
	if(count($failed) == 0){		
		echo "<p>バージョンアップが完了しました。</p>";
		echo "<p>このバージョンアッププログラムは削除することを推奨します。</p>";
	}else{
		echo "<p>".count($sites) ."個中".count($failed)."個のサイトでバージョンアップが失敗しました。";
		echo "<p>エラーログ</p>";
		foreach($failed as $key => $value){
			$title = $sites[$key]->getSiteName();
			echo "<h3>サイト名：" . $title. "</h3>";
			echo "<pre>";
			echo $value;
			echo "</pre>";
		}
	}
	
}
?>